#Ze_PilOt <thepilot@easynet.be>
#murder party 1.0b3

local originalBeginSession = BeginSession

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local cur = {
murderList = nil,

}


msgOut = function(text, army)
local color = nil;
if (army != nil) then
	local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor;
	color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex];
end
PrintText(text, 20, color, 10, 'center') ;
end


function BonusRessourceThread()

	while true do
		WaitSeconds(0.1)
		local mass = 0
		local energy = 0
		local bonus = 0
		for index, army in ArmyBrains do
	
			local curArmy = army:GetArmyIndex()
			local brain = GetArmyBrain(curArmy)
			bonus =	brain:GetArmyStat("bonusPred",0.0).Value
			energy = brain:GetEconomyIncome('ENERGY')
			mass = brain:GetEconomyIncome('MASS')
	
			
				brain:GiveResource('MASS',  mass * ( bonus * .05))
				brain:GiveResource('ENERGY', energy * ( bonus * .05))
				
					
		end
	
	end

end



getUsername = function(army)
return GetArmyBrain(army).Nickname;
end

function OnPopulate()
ScenarioUtils.InitializeArmies()
end


function tableRandomize(Table)
local RandTable = {}
local CopyTable = Table


-- While we still have stuff left


while (table.getn(CopyTable) > 0) do
	-- Get a random value
	local Rand = math.random(1, table.getn(CopyTable))

	-- Insert the random value to the new table
	table.insert(RandTable, CopyTable[Rand])

	-- Remove the key
	table.remove(CopyTable, Rand)

	-- Add one to the count (remove this if you want)

end

return RandTable
end




function checkDeadThread(army)

local curPlayerInfo = army:GetArmyIndex()
local var = GetArmyBrain(curPlayerInfo).Nickname


end



function getPrey(player)

local prey

	for index, army in cur.MurderList do
	
	
		
		local curPlayerInfo = army:GetArmyIndex()
		
			if curPlayerInfo == player then
				---- on check qui est la proie
				if index != table.getn(cur.MurderList) then
					prey =  next(cur.MurderList,index)
				end
				if index == table.getn(cur.MurderList) then
					prey =  next(cur.MurderList)
				end
			end
		
		end

return cur.MurderList[prey]:GetArmyIndex()
end


function getPredator(player)

local predator

	for index, army in cur.MurderList do

		local curPlayerInfo = army:GetArmyIndex()
		
			if curPlayerInfo == player then
				--- on check qui est le predator
				if index == 1 then
					predator = table.getn(cur.MurderList)
					break
				end
				if index != 1 then
					predator = index-1
					break
				end
			end
		
		end

return cur.MurderList[predator]:GetArmyIndex()
end

function givePreyThread(MurderPlayers)

for index, army in MurderPlayers do

	-- curPlayerInfo = players en cours dans l'index
	local curPlayerInfo = army:GetArmyIndex()
	local playerToKill = 0

	-- si on depasse pas le nombre de players dans l'index, on prend le suivant, no prob
	if index != table.getn(MurderPlayers) then
		playerToKill =  next(MurderPlayers,index)
	end
	-- si on sort de l'index, on prend le premier joueur de la liste
	if index == table.getn(MurderPlayers) then
		playerToKill =  next(MurderPlayers)
	end


	-- du coup, var2 = le pseudo du joueur suivant

	local playerToKillInfo = MurderPlayers[playerToKill]:GetArmyIndex()

	local var2 = GetArmyBrain(playerToKillInfo).Nickname
	local var = GetArmyBrain(curPlayerInfo).Nickname

	if curPlayerInfo == GetFocusArmy() then

		if var != var2 then 
			text = LOCF('%s, your mission is to kill %s', var, var2) 
			WaitSeconds(10)
			PrintText(text, 20, nil, 15, 'center')
		end
	end

	LOG('This is the predator = ', var)
	LOG('This is the prey = ', var2)
end

end


getCommanders = function(army)
local list = GetArmyBrain(army):GetListOfUnits(categories.COMMAND , false);
for i, u in list do
	if (u:IsDead() == false) then
		return u;
	end
end
end

function MPMainThread()

local ArmyScore = {}

local Bonus_Resource_Thread = ForkThread(BonusRessourceThread)

for army, brain in ArmyBrains do
	brain:AddArmyStat("assasination",0)
	brain:AddArmyStat("bonusPred",0)

	brain.CalculateScore = MPCalculateScore
end

local MurderPlayers = {}
local MurderPlayers2 = {}

for index, army in ArmyBrains do
	if ArmyIsCivilian(index) == false and ArmyIsOutOfGame(index) == false then
		table.insert(MurderPlayers, army)



	end
end
cur.MurderList = tableRandomize(MurderPlayers)

--on insere un trigger sur les commandeurs

local give_Prey_thread = ForkThread(givePreyThread, cur.MurderList)

for index, army in cur.MurderList do

	local commanderList = getCommanders(index)
	
	commanderList.OldOnKilled = commanderList.OnKilled;
	commanderList.OnKilled = function(self, instigator, type, overkillRatio)

	myArmy = self:GetArmy() 

	if instigator then

	local prey = getPrey(myArmy)
	local preyNickname = GetArmyBrain(prey).Nickname
	LOG('the prey was ',preyNickname)
	
	local predator = getPredator(myArmy)
	local predNickname = GetArmyBrain(predator).Nickname
	LOG('the predator was ',predNickname)
	
	
	if instigator and instigator:GetArmy() == predator then
		-- le tueur etait le predator, il gagne !
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("assasination",1)
			brain:AddArmyStat("bonusPred",2)
	end

	if instigator and instigator:GetArmy() == prey then
		-- le tueur etait la proie, il gagne un bonus
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("bonusPred",1)
	end

	if instigator and instigator:GetArmy() != prey and instigator:GetArmy() != predator then
		-- n'importe quel autre tueur
			local brain = ArmyBrains[instigator:GetArmy()]
			brain:AddArmyStat("assasination",-1)
			brain:AddArmyStat("bonusPred",-2)
	end
end
	if not instigator or instigator:GetArmy()== myArmy then
			local brain = ArmyBrains[myArmy]
			LOG('Suicide/deco!') 
			brain:AddArmyStat("assasination",-1)
			
	end

	self.OldOnKilled(self, instigator, type, overkillRatio);

end

end



local end_game = false
local old_players_alive = -1


while end_game == false do
	WaitSeconds(0.1)
	--- begin loop
	local oldPlayerList = cur.MurderList
	local deadGuy = -1
	for index, army in oldPlayerList do
		local curPlayer = army:GetArmyIndex()
		-- check for dead guy in the list
		if	ArmyIsCivilian(curPlayer) == false and ArmyIsOutOfGame(curPlayer) == true then
			local check_Dead_Thread = ForkThread(checkDeadThread,army)
			-- and we remove it from the list of players
			table.remove(cur.MurderList, index)
			deadGuy = 1
			-- end if
		end

		---end for
	end


	if deadGuy == 1 then


		local give_Prey_thread = ForkThread(givePreyThread, cur.MurderList)
	end

	--- end loop



end


end

function OnStart()
local MP_main_thread = ForkThread(MPMainThread)

end


function BeginSession()
LOG('beginning sim')
originalBeginSession()
LOG('Begin the hunt')
OnStart()

end


function MPCalculateScore(self)
local success = self:GetArmyStat("assasination",0.0).Value
return math.floor(success)
end